<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task502B.20</title>
</head>

<body>

</body>

<script>
    class Car {
        // Khai báo thuộc tính
        _name;
        _year;
        // Khai báo hàm khởi tạo
        constructor(paramName, paramYear) {
            this._name = paramName;
            this._year = paramYear;
        }
        //Phương thức getter & setter
        //getter
        getName() {
            return this._name;
        }

        //setter
        setName(paramName) {
            this._name = paramName;
        }

        // Phương thức khác
        getAge() {
            let today = new Date();

            return today.getFullYear() - this._year;
        }
    }

    //Khởi tạo các thực thể
    var car1 = new Car("BMW", 2019);
    var car2 = new Car("Madza", 2012);

    console.log(car1.getName());
    console.log(car2.getName());

    car1.setName("BMW I8");
    console.log(car1.getName());

    console.log(car1.getAge());
    console.log(car2.getAge());


    class Rectangle {
        _length;
        _width;

        constructor(paramLength, paramWidth) {
            this._length = paramLength;
            this._width = paramWidth;
        }

        getArea() {
            return this._length * this._width;
        }
    }

    class Square extends Rectangle {
        
        constructor(paramLength) {
            super(paramLength, paramLength);
        }

        getPerimeter() {
            return 2 * (this._length + this._width);
        }
    }

    var rectangle1 = new Rectangle(5, 10);
    var rectangle2 = new Rectangle(10, 20);

    console.log(rectangle1.getArea());
    console.log(rectangle2.getArea());

    var square1 = new Square(5);
    var square2 = new Square(10);

    console.log(square1.getArea());
    console.log(square2.getArea());

    console.log(square1.getPerimeter());
    console.log(square2.getPerimeter());

    console.log(rectangle1 instanceof Rectangle);
    console.log(rectangle1 instanceof Square);
    console.log(square1 instanceof Rectangle);
    console.log(square2 instanceof Square);
</script>

</html>